/* ------------------------------------------------------------------------- */
/*!
 *  \file       mgl_task_node_list_element.h
 *  \brief      MGL タスクリストのノード要素
 *  \date       Since: March 30, 2023. 17:43:08 JST.
 *  \author     Acerola
 */
/* ------------------------------------------------------------------------- */

#ifndef INCGUARD_MGL_TASK_NODE_LIST_ELEMENT_H_1680165788
#define INCGUARD_MGL_TASK_NODE_LIST_ELEMENT_H_1680165788

#include <mgl/task/mgl_task_node.h>

namespace MGL::Task
{
//! ノードの要素
struct NodeListElement
{
    STL::unique_ptr<Node> node;     //!< このノード
    NodeListElement *next;          //!< 次のノード
    NodeListElement *previous;      //!< 前のノード
    UniqueIdentifier uniqueID;      //!< ユニークID
    size_t arrayIndex;              //!< 配列上のインデックス

    //! コンストラクタ
    constexpr NodeListElement() noexcept
        : node(nullptr)
        , next(nullptr)
        , previous(nullptr)
        , uniqueID(UniqueIdentifier::Invalid)
        , arrayIndex(0)
    {}
};
}   // namespace MGL::Task

#endif	// INCGUARD_MGL_TASK_NODE_LIST_ELEMENT_H_1680165788

// vim: et ts=4 sw=4 sts=4
